#!/usr/bin/perl
#
# junky script to "deflate" a SWF -- turn files in current directory
# into a SWF
#
# ADOBE SYSTEMS INCORPORATED
# Copyright 2008 Adobe Systems Incorporated. All Rights Reserved.
#
# NOTICE:  Adobe permits you to use, modify, and distribute this file in
# accordance with the terms of the Adobe license agreement accompanying it.
# If you have received this file from a source other than Adobe, then your use,
# modification, or distribution of it requires the prior written permission of Adobe.
#

open(OUT, ">$ARGV[0]");
binmode(OUT);

undef $/;

@files = sort(<*>);

foreach $file (@files)
{
  if($file =~ /[0-9]{6}(?:_([0-9a-f]{4,8})_(.*))?\.([0-9a-f]{3}|head)/)
  {
    $a = $1;
    $b = $2;
    $tag = ($3 eq "head") ? -1 : hex($3);

    open(BLOCK, $file);
    binmode(BLOCK);
    $data = <BLOCK>;
    close(BLOCK);
    if($tag == -1)
    {
      # no block header
    }
    else
    {
      if($tag == 82) # ABC2
      {
        $b =~ s/_([0-9a-f]{2})/chr(hex($1))/eg;
        $data = pack("V", hex($a)) . $b . "\0" . $data;
      }
      elsif($tag == 87) # Binary data
      {
        $data = pack("Vv", hex($a), hex($b)) . $data;
      }
      print OUT pack("vV", ($tag << 6) | 0x3f, length($data));
    }
    print OUT $data;
  }
}

$swflen = tell(OUT);
seek(OUT, 4, 0);
print OUT pack("V", $swflen);
